/* ----------------------------------------------------------------------------
library name :pio.h - by this library you can work with at91sam family port(I/O) without
any long statment . for exmaple : AT91F_PIO_ClearOutput(AT91C_BASE_PIOB, AT91C_PIO_PB0)
 ;  conversion to : PORTB = 0x1 ; & whatnot.. it's very good and you can remember that.
this library is provide by 1NAFAR (at91sam7x645@gmail.com) for at91sam series 
you can edit , remove & change all parts af that .also you can download other 
library for other atmel & nxp products (AT91-LPC series)from WWW.IRANMICRO.IR 
you can access to descriptions I/O Line Resistor Control in PMM magazine .for 
more information please visit : www.iranmicro.ir/forum/forumdisplay.php?f=221
for use this library :first set port state as output or input by 
PORTx_OUTPUT or PORTx_INPUT . for example : PORTA_OUTPUT = 0x1 ; 
configure porta.0 as outputor PORTA_INPUT = 0x2 ; porta.1 set as 
input . 2-send your data to port by SET_PORTx=?? or RST_PORTx=??
or PORTx=? for input state you must use a condition program, you
can use if-elseif or whaile (????) . for more information please
read PMM1 or test project (io.c) also pg 229 to 254	at91sam7x256 
datasheets ( Preliminary ) can help you	for recognition Resistor

 
----------------------------------------------------------------------------*/


#ifndef pio_H
#define pio_H
#define	    PORTA_OUTPUT *AT91C_PIOA_PER=*AT91C_PIOA_OER=*AT91C_PIOA_OWER // Port Enable Resistor for port x(a,b or c  , d )
#define	   	PORTB_OUTPUT *AT91C_PIOB_PER =*AT91C_PIOB_OER= *AT91C_PIOB_OWER
#define	   	PORTC_OUTPUT *AT91C_PIOC_PER=*AT91C_PIOC_OER= *AT91C_PIOC_OWER
#define	   	PORTD_OUTPUT *AT91C_PIOD_PER=*AT91C_PIOD_OER =*AT91C_PIOD_OWER
//Output Enable Resistor for port x(a,b or c  , d )  
#define	    PORTA_INPUT *AT91C_PIOA_PER=*AT91C_PIOA_ODR   //Input Enable(Output Disable Register) Resistor for port x(a,b or c  , d ) 
#define	   	PORTB_INPUT *AT91C_PIOB_PER =*AT91C_PIOB_ODR
#define	   	PORTC_INPUT *AT91C_PIOC_PER=*AT91C_PIOB_ODR
#define	   	PORTD_INPUT *AT91C_PIOD_PER=*AT91C_PIOD_ODR
#define	    PERA *AT91C_PIOA_PER  // Port Enable Resistor for port x(a,b or c  , d )
#define	   	PERB *AT91C_PIOB_PER
#define	   	PERC *AT91C_PIOC_PER
#define	   	PERD *AT91C_PIOD_PER
#define	    OERA *AT91C_PIOA_OER //Output Enable Resistor for port x(a,b or c  , d ) 
#define	   	OERB *AT91C_PIOB_OER
#define	   	OERC *AT91C_PIOC_OER
#define	   	OERD *AT91C_PIOD_OER
#define	    IERA *AT91C_PIOA_ODR //Input Enable(Output Disable Register) Resistor for port x(a,b or c  , d ) 
#define	   	IERB *AT91C_PIOB_ODR
#define	   	IERC *AT91C_PIOC_ODR
#define	   	IERD *AT91C_PIOD_ODR
#define	    DDRA *AT91C_PIOA_OWER  // direct driver Enable Resistor for port x(a,b or c  , d )
#define	   	DDRB *AT91C_PIOB_OWER
#define	   	DDRC *AT91C_PIOC_OWER
#define	   	DDRD *AT91C_PIOD_OWER
#define	    PULL_UP_A *AT91C_PIOA_PPUER //Pull-up Enable Resistor for port x(a,b or c  , d ) 
#define	   	PULL_UP_B *AT91C_PIOB_PPUER
#define	   	PULL_UP_C *AT91C_PIOC_PPUER
#define	   	PULL_UP_D *AT91C_PIOD_PPUER
#define	    MDERA *AT91C_PIOA_PCER //Multi-driver  Enable Resistor for port x(a,b or c  , d )(configured Port as open drain) 
#define	   	MDERB *AT91C_PIOB_PCER
#define	   	MDERC *AT91C_PIOC_PCER
#define	   	MDERD *AT91C_PIOD_PCER
#define	    MDDRA *AT91C_PIOA_MDDR//Multi-driver  disable Resistor for port x(a,b or c  , d )(configured Port as open drain) 
#define	   	MDDRB *AT91C_PIOB_MDDR
#define	   	MDDRC *AT91C_PIOC_MDDR
#define	   	MDDRD *AT91C_PIOD_MDDR
#define	    IFERA *AT91C_PIOA_IFER//input filter  Enable Resistor for port x(a,b or c  , d )(configured Port as open drain) 
#define	   	IFERB *AT91C_PIOB_IFER
#define	   	IFERC *AT91C_PIOC_IFER
#define	   	IFERD *AT91C_PIOD_IFER
#define	    IFDRA *AT91C_PIOA_IFDR//input filter  disable Resistor for port x(a,b or c  , d )(configured Port as open drain) 
#define	   	IFDRB *AT91C_PIOB_IFDR
#define	   	IFDRC *AT91C_PIOC_IFDR
#define	   	IFDRD *AT91C_PIOD_IFDR
#define	   	PAER *AT91C_PIOC_ASR	  //PERIPH A Enable Resistor
#define	   	PBER *AT91C_PIOC_BSR	   //PERIPH B Enable Resistor
#define	    INERA *AT91C_PIOA_IER//Interrupt  Enable Resistor for port x(a,b or c  , d )(configured Port as open drain) 
#define	   	INERB *AT91C_PIOB_IER
#define	   	INERC *AT91C_PIOC_IER
#define	   	INERD *AT91C_PIOD_IER
#define	    INDRA *AT91C_PIOA_IDR//Interrupt  Disable Resistor for port x(a,b or c  , d )(configured Port as open drain) 
#define	   	INDRB *AT91C_PIOB_IDR
#define	   	INDRC *AT91C_PIOC_IDR
#define	   	INDRD *AT91C_PIOD_IDR
#define	   	SET_PORTA *AT91C_PIOA_SODR	//SET 	 port x(a,b or c  , d )  
#define	   	SET_PORTB *AT91C_PIOB_SODR
#define	   	SET_PORTC *AT91C_PIOC_SODR
#define	   	SET_PORTD *AT91C_PIOD_SODR
#define	   	RST_PORTA *AT91C_PIOA_CODR	//RESET 	 port x(a,b or c  , d )  
#define	   	RST_PORTB *AT91C_PIOB_CODR
#define	   	RST_PORTC *AT91C_PIOC_CODR
#define	   	RST_PORTD *AT91C_PIOD_CODR
#define	   	PORTA *AT91C_PIOA_ODSR 	//SET -RESET 	 port x(a,b or c  , d )  
#define	   	PORTB *AT91C_PIOB_ODSR 
#define	   	PORTC *AT91C_PIOC_ODSR 
#define	   	PORTD *AT91C_PIOD_ODSR
unsigned int port_data;

__inline unsigned int PINA(char PIN) {
*AT91C_PMC_PCER= (1 << AT91C_ID_PIOA);
switch (PIN)
{
	case 0:		    	
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA0 );		
break;		
	case 1:	
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA1 );
	break;
		case 2:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA2 )	;
	break;	
	case 3:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA3 )	;
	
	break;
		case 4:
	
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA4 );
		
	 break;

	case 5:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA5 );

	break;
		case 6:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA6 );
	break;

	case 7:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA7 );
	break;
case 8:		    	
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA8 );		
break;													
	case 9:												   
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA9 );
	break;
		case 10:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA10 );	
	break;	
	case 11:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA11 );
	
	break;
		case 12:
	
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA12 );
		
 	 break;

	case 13:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA13 );

	break;
		case 14:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA14 ) ;
	break;

	case 15:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA15 );
	break;
case 16:		    	
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA16 );		
break;		
	case 17:	
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA17 );
	break;
		case 18:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA18 );	
	break;	
	case 19:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA19 );
	
	break;
		case 20:
	
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA20 );
		
	 break;

	case 21:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA21 );

	break;
		case 22:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA22 ) ;
	break;

	case 23:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA23 ) ;
	break;
case 24:		    	
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA24 );		
break;		 
	case 25:	
	port_data==((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA25 );
	break;
		case 26:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA26 );	
	break;	
	case 27:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA27 );
														   
	break;
		case 28:
	
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA28 );
		
	 break;

	case 29:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA29 );

	break;
		case 30:
	port_data= ((AT91C_BASE_PIOA->PIO_PDSR)& AT91C_PIO_PA30 );
	break;



}
	return(port_data);
} 



__inline unsigned int PINB(char PIN) {
*AT91C_PMC_PCER= 1 << AT91C_ID_PIOB;
switch (PIN)
{
	case 0:		    	
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB0 );		
break;		
	case 1:	
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB1 );
	break;
		case 2:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB2 )	;
	break;	
	case 3:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB3 );
	
	break;
		case 4:
	
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB4 );
		
	 break;

	case 5:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB5 );

	break;
		case 6:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB6 );
	break;

	case 7:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB7 );
	break;
case 8:		    	
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB8 );		
break;													
	case 9:	
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB9 );
	break;
		case 10:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB10 );	
	break;	
	case 11:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB11 ) ;
	
	break;
		case 12:
	
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB12 );
															 
	 break;

	case 13:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB13 );

	break;
		case 14:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB14 );
	break;													 

	case 15:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB15 );
	break;
case 16:		    	
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB16 );		
break;		
	case 17:	
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB17 );
	break;
		case 18:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB18 );	
	break;	
	case 19:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB19 );
	
	break;
		case 20:
	
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB20 );
		
	 break;

	case 21:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB21 );

	break;
		case 22:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB22 );
	break;

	case 23:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB23 );
	break;
case 24:		    	
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB24 );		
break;		
	case 25:	
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB25 );
	break;
		case 26:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB26 );	
	break;	
	case 27:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB27 );
	
	break;
		case 28:
	
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB28 );
		
	 break;

	case 29:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB29 );

	break;
		case 30:
	port_data= ((AT91C_BASE_PIOB->PIO_PDSR)& AT91C_PIO_PB30 );
	break;


}
	return(port_data);
} 

/*__inline unsigned int PINC(char PIN) {
*AT91C_PMC_PCER= 1 << AT91C_ID_PIOC;
	return (*AT91C_PIOC_PDSR & PIN);
}
__inline unsigned int PIND(char PIN) {
*AT91C_PMC_PCER= 1 << AT91C_ID_PIOD;
	return (*AT91C_PIOD_PDSR & PIN);
} */
#define PA0        (1 <<  0)
#define PA1        (1 <<  1)
#define PA2        (1 <<  2)
#define PA3        (1 <<  3)
#define PA4        (1 <<  4)
#define PA5        (1 <<  5)
#define PA6        (1 <<  6)
#define PA7        (1 <<  7)
#define PA8        (1 <<  8)
#define PA9        (1 <<  9)
#define PA10        (1 <<  10)
#define PA11        (1 <<  11)
#define PA12        (1 <<  12)
#define PA13        (1 <<  13)
#define PA14        (1 <<  14)
#define PA15        (1 <<  15)
#define PA16        (1 <<  16)
#define PA17        (1 <<  17)
#define PA18        (1 <<  18)
#define PA19        (1 <<  19)
#define PA20        (1 <<  20)
#define PA21        (1 <<  21)
#define PA22        (1 <<  22)
#define PA23        (1 <<  23)
#define PA24        (1 <<  24)
#define PA25        (1 <<  25)
#define PA26        (1 <<  26)
#define PA27        (1 <<  27)
#define PA28        (1 <<  28)
#define PA29        (1 <<  29)
#define PA30        (1 <<  30)
#define PA31        (1 <<  31)

#define PB0        (1 <<  0)
#define PB1        (1 <<  1)
#define PB2        (1 <<  2)
#define PB3        (1 <<  3)
#define PB4        (1 <<  4)
#define PB5        (1 <<  5)
#define PB6        (1 <<  6)
#define PB7        (1 <<  7)
#define PB8        (1 <<  8)
#define PB9        (1 <<  9)
#define PB10        (1 <<  10)
#define PB11        (1 <<  11)
#define PB12        (1 <<  12)
#define PB13        (1 <<  13)
#define PB14        (1 <<  14)
#define PB15        (1 <<  15)
#define PB16        (1 <<  16)
#define PB17        (1 <<  17)
#define PB18        (1 <<  18)
#define PB19        (1 <<  19)
#define PB20        (1 <<  20)
#define PB21        (1 <<  21)
#define PB22        (1 <<  22)
#define PB23        (1 <<  23)
#define PB24        (1 <<  24)
#define PB25        (1 <<  25)
#define PB26        (1 <<  26)
#define PB27        (1 <<  27)
#define PB28        (1 <<  28)
#define PB29        (1 <<  29)
#define PB30        (1 <<  30)
#define PB31        (1 <<  31)
#endif

